#include <stdio.h>
#include <stdlib.h>
#include <mpi.h>
#include "readvectors.h"

main(int argc, char *argv[])
{
	const int tag = 50;
	int id, ntasks, source_id, dest_id, rc, i;
	MPI_Status status;
	int msg[2];

	int size;
	int *arr1,*arr2;
	int result=0;
	char *filename;
	int numread,length;

rc = MPI_Init(&argc, &argv);


if (rc != MPI_SUCCESS) {

	printf("MPI Init failed\n");
	exit(1);
}

rc = MPI_Comm_size(MPI_COMM_WORLD, &ntasks);
rc = MPI_Comm_rank(MPI_COMM_WORLD, &id);


						
if ( id != 0 ) { 
	int res;

	dest_id = 0;

	rc = MPI_Recv(&size, 1, MPI_INT, dest_id, tag, MPI_COMM_WORLD, &status);
	arr1 = malloc(sizeof(int)*size);
	arr2 = malloc(sizeof(int)*size);
	
	rc = MPI_Recv(arr1, size, MPI_INT, dest_id, tag, MPI_COMM_WORLD, &status);
	rc = MPI_Recv(arr2, size, MPI_INT, dest_id, tag, MPI_COMM_WORLD, &status);
        for (i=0;i<size;i++) {
                result+=arr1[i]*arr2[i];
        }
	printf("task %i, data size %i received\n",id,size);
	
	for (i =1; i < ntasks; i = i*2) {
		if ((id -i -1) % (i*2) == 0){
			dest_id = id -i;
			printf("task %i, sending result to task %i\n",id,dest_id);
			rc = MPI_Send(&result, 1, MPI_INT, dest_id, tag, MPI_COMM_WORLD);
		}
		if (((id-1) % (i*2) == 0) && (id+i < ntasks)) {
			printf("task %i, receiving result from task %i\n",id,id+i);
			rc = MPI_Recv(&res, 1, MPI_INT, id+i, tag, MPI_COMM_WORLD, &status);
			result+=res;
		}
	}
	if (id == 1)
		rc = MPI_Send(&result, 1, MPI_INT, 0, tag, MPI_COMM_WORLD);

} else { 
int res,start,sublength;

	filename = argv[1];
       arr1 = malloc(sizeof(int)*10);
       arr2 = malloc(sizeof(int)*10);
       length = 10;
       readvectors(filename, &arr1,&arr2, &length, &numread);

for (i=0;i < ntasks -1; i++) {

	start = numread/(ntasks-1)*i;
	sublength = numread/(ntasks-1);
	if (i == ntasks - 2 )
		sublength += numread % (ntasks-1);
	printf("%i %i %i\n",i+1,start,sublength);
	rc = MPI_Send(&sublength, 1, MPI_INT, i+1, tag, MPI_COMM_WORLD);
	rc = MPI_Send(arr1+start, sublength, MPI_INT, i+1, tag, MPI_COMM_WORLD);
	rc = MPI_Send(arr2+start, sublength, MPI_INT, i+1, tag, MPI_COMM_WORLD);
	
	
}
	printf("waiting for result\n");
	rc = MPI_Recv(&res, 1, MPI_INT,  1, tag, MPI_COMM_WORLD, &status);
	result= res;
	printf("Result is %i\n",result);
}


MPI_Finalize();

exit(0);

}
