#include <stdio.h>
#include <stdlib.h>
#include "readvectors.h"

#define _REENTRANT
#include<pthread.h>


int numproc;


void *sub(void *);



typedef struct threaddata threaddata;

struct threaddata {
	int *arr1;
	int *arr2; 
	int start;
	int stop;
	int result;
	int gotresult;
	pthread_cond_t haveresult;
	pthread_mutex_t mutex;
	int number;
	threaddata *data;
};

int main(int argc, char *argv[])
{
	char *filename;
	
	int length, numread;
	int *arr1,*arr2;

	int i;
	pthread_t *threads;
	threaddata *data;
	int result=0;

	printf("test");	
	if (argc != 3) {
		printf("Usage: prog filename numproc\n");
		return 1;
	}
	filename = argv[1];
	numproc = atoi(argv[2]);
	arr1 = malloc(sizeof(int)*10);
	arr2 = malloc(sizeof(int)*10);
	length = 10;
	readvectors(filename, &arr1, &arr2, &length, &numread);
	
	printf("\n%s %i\n",filename,numproc);
	for ( i=0; i < numread; i++) {
		printf("%i ",arr1[i]);
	}	

	if (numproc > numread) {
		numproc = numread;
	}

	threads = (pthread_t *)malloc(numproc*sizeof(pthread_t));
	data = (threaddata *)malloc(numproc*sizeof(threaddata));

	printf("This is main thread\n");

	
	
	for (i=0;i<numproc;i++) {
		data[i].arr1 = arr1;
		data[i].arr2 = arr2;
		data[i].result = 0;
		data[i].start = numread/numproc*i;
		data[i].stop = numread/numproc*(i+1);
		data[i].number = i;
		data[i].data = data;
		data[i].gotresult = 0;
		if (i == numproc - 1 )
			data[i].stop += numread % numproc;
		pthread_mutex_init(&(data[i].mutex), NULL);
		pthread_cond_init(&(data[i].haveresult),NULL);

	}
	
	for (i=0;i<numproc;i++) {
		if (pthread_create(&threads[i], NULL, sub, &data[i] ))
		         fprintf(stderr, "Can't create thread\n"), exit(1);
		}

	printf("Main thread still\n");

	for (i=0;i<numproc;i++) {
		if (pthread_join(threads[i], NULL)!=0) {perror("Join error\n"); exit(-1);}
        }

	result = data[0].result;
	printf("Result is %i\n",result);
}

void * sub(void *arg)
{
	threaddata *data = (threaddata *) arg;
	int me;
	int i;
	pthread_mutex_t *mutex;
	pthread_cond_t *cond;

	me = pthread_self();

	printf("This is thread %i\n", me);

	pthread_mutex_lock(&(data->mutex));
	for (i=data->start; i < data->stop; i++)
		data->result += (data->arr1[i]*data->arr2[i]);
	printf("Thread %i calculated own subtask, result %i\n",data->number,data->result);


	for (i =1; i+(data->number) < numproc; i = i * 2) {
		if (((data->number) % (i*2)) == 0 ) {
		    mutex = &((data->data)[(data->number)+i].mutex);
		    cond = &((data->data)[(data->number)+i].haveresult);
		    pthread_mutex_lock(mutex);
		    printf("Thread %i collects data from thread %i\n",data->number, (data->number) +i);
		    if ((data->data)[(data->number)+i].gotresult == 0) {
		        pthread_cond_wait(cond,mutex);
		    }
		    (data->result)+= (data->data)[(data->number)+i].result;
		    pthread_mutex_unlock(mutex);
		    printf("Thread %i collected data from thread %i\n",data->number, (data->number) +i);
		}

	}
	printf("Thread %i has collected all data and is about to quit\n",data->number);
	data->gotresult = 1;
	pthread_cond_broadcast(&(data->haveresult));
	pthread_mutex_unlock(&(data->mutex));
	return NULL;
}

